climatedemo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
# from histo.views import main
from django.views.generic import TemplateView

from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('climap/', include('climap.urls')),
    path('stats/', include('stats.urls')),
    path('proj/', include('proj.urls')),
    path('favicon.ico',
        RedirectView.as_view( # the redirecting function
            url=staticfiles_storage.url('img/favicon.ico'), # converts the static directory + our favicon into a URL
        ),
        name="favicon" # name of our view
    ),
    path('', TemplateView.as_view(template_name='proj/main.html'), name='main'),
]

# if not settings.DOCKER:
#     urlpatterns.insert(0, path('climap/', include('climap.urls')))

histo/urls.py
from django.urls import path

from . import views

app_name = 'histo'

urlpatterns = [
    path('station/<int:sid>', views.index, name='station'),
    path('', views.index, name='index'),
    ]

proj/urls.py
from django.urls import path, register_converter
from django.views.generic import TemplateView
from . import views
from .export import image
from .netcdf import write_netcdf
from .maintenance import print_zd, del_zd, del_mrd, print_sp, del_sp, display_station_proj, print_param, del_param, listings

app_name = 'proj'

class Extension:
    regex = '[a-z]{2,3}'

    def to_python(self, value):
        return str(value)

    to_url = to_python

register_converter(Extension, 'xxx')

urlpatterns = [
    # static
    path('about', views.about, name='about'),
    path('help', views.help, name='help'),
    path('formula', views.formula, name='formula'),
    path('download', views.download, name='download'),
    path('faq', TemplateView.as_view(template_name='proj/faq.html'), name='faq'),

    path ('downparam/<pr>_<scen>_<zone>.csv', views.param_download, name='param_download'),
    path('downmetric/<met>_<scen>_<model>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<met>_<scen>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<metric>_<scen>_<model>.nc', write_netcdf, name='netcdf'),
    path('downzone/<met>_<scen>_<zone>.csv', views.zone_metric_download, name='zone_download'),

    # json / export
    path('<update>.json', views.jsoner, name='jsoner'),
    path('<period>.csv', views.csv_export, name='csv'),
    path('<period>.xls', views.xls_export, name='xls'),
    path('export.<xxx:extension>', image, name='plt'),

    # language toggle
    path('lang/<l>', views.lang, name='lang'),

    # main page
    path('simple', views.simple, name='simple'),
    path('', views.index, name='index'),

    # admin
    path('listings', listings, name='listings'),
    path('mod_zd', print_zd, name='print_zd'),
    path('mod_param', print_param, name='print_param'),
    path('mod_sp', print_sp, name='print_sp'),
    path('stations', display_station_proj, name='display_station'),
    path('del_zd/<mid>/<modname>/<scen>', del_zd, name='del_zd_scen'),
    path('del_zd/<mid>/<modname>', del_zd, name='del_zd'),
    path('del_param/<pid>/<modname>/<scen>', del_param, name='del_param_scen'),
    path('del_param/<pid>/<modname>', del_param, name='del_param'),
    path('del_mrd/<mid>/<modname>/<scen>', del_mrd, name='del_mrd_scen'),
    path('del_mrd/<mid>/<modname>', del_mrd, name='del_mrd'),
    path('del_sp/<modname>/<pid>/<sid>/<scen>', del_sp, name='del_sp_scen'),
    path('del_sp/<modname>/<pid>/<sid>/', del_sp, name='del_sp'),
    ]

stats/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required
from django.contrib.auth.views import LoginView
from django.views.generic import TemplateView

from . import views
app_name = 'stats'

urlpatterns = [
    path('login', LoginView.as_view(), name='login'),
    path('doc', TemplateView.as_view(template_name='stats/doc.html'), name='doc'),
    path('metric/<ip>', views.proj_metric, name='metric_by_ip'),
    path('metric', views.proj_metric, name='metric'),
    path('metriccsv', views.proj_metric_csv, name='metric_csv'),
    path('comments', login_required(views.CommentListView.as_view()), name='comments'),
    path('commentwrite', views.CommentCreate.as_view(), name='commentwrite'),
    path('commentdel/<int:pk>', login_required(views.CommentDelete.as_view()), name='commentdel'),
    path('', views.index, name='index'),
]

stats/models.py
from django.db import models

# Create your models here.

# SITE METRICS

class Metric(models.Model):
    """Abstract metric class."""
    class Meta:
        abstract = True
    date = models.DateTimeField(auto_now_add=True)
    ip = models.GenericIPAddressField(null=True)
    nav = models.CharField(max_length=100)


class ProjMetric(Metric):
    url = models.CharField(max_length=400)
    logged = models.BooleanField()

    def url_as_list(self):
        return ', '.join(self.url.split('&'))

class HistoMetric(Metric):
    station_id = models.IntegerField(null=True)
    logged = models.BooleanField()

# COMMENTS

class Comment(models.Model):
    name = models.CharField(max_length=100, default='anonymous')
    mail = models.EmailField(max_length=50, blank=True, help_text='not mandatory')
    comment = models.TextField()
    date = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return '{} comment ({})'.format(self.name, self.date.strftime('%d/%m/%y'))

stats/views.py
import pandas as pd

from django.shortcuts import render, reverse
from django.urls import reverse_lazy
from django.http import HttpResponse
from django.views.generic.edit import CreateView, DeleteView
from django.views.generic import ListView

from . import models as sm

# Create your views here.

# Site metric views

from django.contrib.auth.decorators import login_required

@login_required
def index(request):
    return render(request, 'stats/index.html')


def metric(request, qset, ip, template):
    if ip:
        qset = qset.filter(ip=ip)
    if 'nolog' in request.GET:
        qset = qset.exclude(logged=True)
    n = int(request.GET.get('n', 100))
    total = qset.count()
    context = {
        'requestmetric_list': qset.order_by('-date')[:n],
        'ip': ip,
        'n': min(n, total),
        'total': total,
    }
    return render(request, template, context)


# @login_required
# def proj_metric(request, ip=None):
#     return metric(request, sm.ProjMetric.objects.all(), ip, 'stats/projmetric_list.html')

@login_required
def proj_metric(request, ip=None):
    pset = sm.ProjMetric.objects.all()
    hset = sm.HistoMetric.objects.all()
    if ip:
        pset = pset.filter(ip=ip)
        hset = hset.filter(ip=ip)
    if 'nolog' in request.GET:
        pset = pset.exclude(logged=True)
        hset = hset.filter(ip=ip)
    n = int(request.GET.get('n', 100))
    ptotal = pset.count()
    htotal = hset.count()
    context = {
        'pset': pset.order_by('-date')[:n],
        'hset': hset.order_by('-date')[:n],
        'ip': ip,
        'pn': min(n, ptotal),
        'ptotal': ptotal,
        'hn': min(n, htotal),
        'htotal': htotal,
        'nolog': 'nolog' in request.GET,
    }
    return render(request, 'stats/projmetric_list.html', context)

def metric_df(qset):
    l = list(zip(*qset.values_list('date', 'ip')))
    df = pd.DataFrame(l[1], index=l[0]).resample('D', kind='period')

    return df.agg(['count', 'nunique'])

@login_required
def proj_metric_csv(request):
    opts = {'ip': None}
    if 'nolog' in request.GET:
        opts = { 'logged': True}
    df = metric_df(sm.ProjMetric.objects.exclude(**opts))
    # df = pd.concat([metric_df(sm.ProjMetric.objects.exclude(**opts)),
    #                 metric_df(sm.HistoMetric.objects.exclude(**opts))],
    #                axis=1)
    r = HttpResponse('date,proj_total,proj_unique,histo_total, histo_unique\n')
    df.to_csv(r, header=False)
    return r

# Comment form

class CommentCreate(CreateView):
    model = sm.Comment
    fields = ['name', 'mail', 'comment']
    success_url = reverse_lazy('main')

class CommentListView(ListView):
    model = sm.Comment

class CommentDelete(DeleteView):
    model = sm.Comment
    success_url = reverse_lazy('stats:comments')

stats/templates/stats/base.html
<!doctype html>
<html lang="en">
<head>
    {% load static %}
    {% block scripts %}{% endblock %}
    <link rel="icon" href="{% static 'img/favicon.ico' %}">
    <link rel="stylesheet" href="{% static 'style.css' %}" type="text/css">
    <link rel="stylesheet" href="{% static 'respstyle.css' %}" type="text/css">

    <title>Géoportail Sénégal</title>
</head>
<body>
<div id="head" style="height:50px">
    <h2><a href="{% url 'main' %}">Géoportail Sénégal</a></h2>
    {% block headinfo %}{% endblock %}
    <div class="links">
        {% block links %}{% endblock %}
    </div>

</div>
<div class="smallpage">
{% block content %}{% endblock %}
</div>
</body>
</html>

stats/templates/stats/comment_confirm_delete.html
{% extends 'stats/logbase.html' %}

{% block content %}
<div class="smallpage">
        Really delete "{{ object }}" ?
        <form method="post">
        {% csrf_token %}
        <input type="submit" value="Delete" />
    </form>
</div>
{% endblock %}

stats/templates/stats/comment_form.html
{% extends 'stats/base.html' %}
{% comment %}Translation{% endcomment %}
{% load i18n %}

{% block content %}
<div class="smallpage">
    <h2>{% trans 'Comment' %}</h2>
    <p>
    {% blocktrans trimmed %}
    You may post any feedback about the portal. Comments may be anonymous,
    but you can leave an adress for a follow-up. It will not be used for any other used.
    {% endblocktrans %}
    </p>
    <form method="post">
        {% csrf_token %}
        <table>
        {{ form.as_table }}
        </table>
        <input type="submit" value="{% trans 'Send' %}" />
    </form>
    <p><a href="{% url 'main' %}">{% trans 'back to the main page' %}</a></p>
</div>
{% endblock %}

stats/templates/stats/comment_list.html
{% extends 'stats/logbase.html' %}

{% block content %}
<div class="smallpage">
    <ul>
        {% for c in comment_list %}
        <li><b>{{ c.name }}</b> {% if c.mail %}(<a href="mailto:{{c.mail}}">{{c.mail}}</a>) {% endif %}<span style="color:gray">on {{ c.date }}</span>
        <br>{{ c.comment }}
        <br><i style="font-size:small"><a href="{% url 'stats:commentdel' c.pk %}">delete this comment</a></i></li>
        {% endfor %}
    </ul>
</div>
{% endblock %}

stats/templates/stats/index.html
{% extends 'stats/logbase.html' %}

{% block content %}
<div class="smallpage">
<dl>
    <dt><a href="{% url 'admin:index' %}">Django admin</a></dt><dd>Main SQL administration (system admin only).</dd>
    <dt><a href="{% url 'stats:comments' %}">Comments</a></dt><dd>Read and delete user comments.</dd>
    <dt><a href="{% url 'stats:metric' %}">Metrics</a></dt><dd>Site metrics and last requests.</dd>
    <dt><a href="{% url 'stats:doc' %}">documentation</a></dt><dd>Administration, in french.</dd>

</dl>
</div>
{% endblock %}

stats/templates/stats/logbase.html
{% extends 'stats/base.html' %}

{% block links %}

<a href="{% url 'main' %}">home</a> &middot;
<a href="{% url 'admin:index' %}">django admin</a> &middot;
<a href="{% url 'stats:comments' %}">comments</a> &middot;
<a href="{% url 'stats:metric' %}">metrics</a> &middot;
<a href="{% url 'stats:doc' %}">documentation</a>

{% endblock %}

stats/templates/stats/projmetric_list.html
{% extends 'stats/logbase.html' %}

{% block scripts %}
{% load static %}
<script src="{% static 'dygraph.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'dygraph.css' %}" type="text/css">
{% endblock %}

{% block content %}
    <div style="margin-left:50px" id="top">
    {% if not ip %}
<!--        <p>Jump to <a href="#proj">'proj' requests</a>, <a href="#histo">'histo' requests</a></p>-->
    <h2>Request history</h2>
    <div id="graphdiv" style="width:80%"></div>
    <p><a style="cursor: pointer"  onclick="toggleCount()">toggle total visibility</a></p>
    {% endif %}
        <h2 id="proj">Last {{ pn }} requests / {{ ptotal }}
            {% if ip %} from {{ ip }} [<a href="{% url 'stats:metric' %}">X</a>]{% endif %}
        </h2>
        <p><a href="#top">Jump to top</a></p>
        {% if ip %}
        <p><a href="{% url 'stats:metric_by_ip' ip %}?n=100">100</a> -
        <a href="{% url 'stats:metric_by_ip' ip %}?n=200">200</a> -
        <a href="{% url 'stats:metric_by_ip' ip %}?n=500">500</a> -
        <a href="{% url 'stats:metric_by_ip' ip %}?n=1000">1000</a></p>
        {% else %}
        <p><a href="{% url 'stats:metric' %}?n=100">100</a> -
        <a href="{% url 'stats:metric' %}?n=200">200</a> -
        <a href="{% url 'stats:metric' %}?n=500">500</a> -
        <a href="{% url 'stats:metric' %}?n=1000">1000</a></p>
        {% endif %}
    <ul>
    {% for rm in pset %}
        <li>
            <a style="color:blue" href="{% url 'stats:metric_by_ip' rm.ip %}">{{rm.ip}}</a> (<a href="https://iplocation.com/?ip={{rm.ip}}">locate</a>) on <span style="color:red">{{rm.date}}</span>
            <span style="color:gray">({{rm.nav}})</span>
            <br><b><a href="{% url 'proj:index' %}?{{rm.url}}">[link]</a></b> {{rm.url_as_list}}
        </li>
    {% endfor %}
    </ul>
        {% comment %}
    <h2 id="histo">'Histo' last {{ hn }} requests / {{ htotal }}
        {% if ip %} from {{ ip }} [<a href="{% url 'stats:metric' %}">X</a>]{% endif %}</h2>

        <p><a href="#top">Jump to top</a></p>
         <ul>
    {% for rm in hset %}
        <li>
            <a style="color:blue" href="{% url 'stats:metric_by_ip' rm.ip %}">{{rm.ip}}</a> (<a href="https://iplocation.com/?ip={{rm.ip}}">locate</a>)</a> on <span style="color:red">{{rm.date}}</span>
            <span style="color:gray">({{rm.nav}})</span>
            {% if rm.station_id %}
            <br><b><a href="{% url 'histo:station' rm.station_id %}">[link]</a></b> station={{rm.station_id}}
            {% endif %}
        </li>
    {% endfor %}
    </ul>
    {% endcomment %}
    </div>



{% if not ip %}
<script type="text/javascript">
    graph = new Dygraph(document.getElementById('graphdiv'),
        "{% url 'stats:metric_csv' %}{% if nolog %}?nolog{% endif %}"
    );
    function toggleCount(){
        // proj_total
        graph.setVisibility(0, !graph.visibility()[0]);
        // histo_total
        graph.setVisibility(2, !graph.visibility()[2]);
    }
</script>
{% endif %}
{% endblock %}